/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.email;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.email.boundary.AbstractEmailLayoutSearchParameters;
import de.ivu.elect.business.email.boundary.EmailLayoutChangeEvent;
import de.ivu.elect.business.email.boundary.EmailLayoutConversationStore;
import de.ivu.elect.business.email.boundary.EmailLayoutExtendedDAO;
import de.ivu.elect.business.email.boundary.EmailLayoutSearch;
import de.ivu.elect.business.email.boundary.EmailLayoutSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.email.entity.EmailLayout;
import de.ivu.elect.business.email.entity.EmailLayoutMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractEmailLayoutSearchView.COMPONENT_NAME)
@View(viewId = AbstractEmailLayoutSearchView.VIEW_ID, useCase = UseCasePermission.EMAIL_LAYOUT_SEARCH)
public abstract class AbstractEmailLayoutSearchView extends AbstractElectSearchView<EmailLayout> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "emailLayoutSearchView";
  
  public static final String VIEW_ID = "/email/email-layout-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractEmailLayoutSearchView requestHandler;

  @Inject
  private transient EmailLayoutExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(EmailLayoutConversationStore.class)
  protected transient EmailLayoutConversationStore conversationStore;

  @Inject
  protected transient EmailLayoutSearch search;

  @Inject
  @ConversationGroup(AbstractEmailLayoutSearchParameters.class)
  protected transient EmailLayoutSearchParameters searchParameters;

  @Inject
  protected transient EmailLayoutMeta entityMeta;

  public AbstractEmailLayoutSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public EmailLayout getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(EmailLayout entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public EmailLayoutSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<EmailLayout> getEagerLoadingCollector() {
    return EagerLoadingCollector.<EmailLayout> create();
  }

  @Override
  public List<EmailLayout> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<EmailLayout> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onEmailLayoutChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) EmailLayoutChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractEmailLayoutSearchView {

    @View
    @Inject
    private transient Instance<AbstractEmailLayoutSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractEmailLayoutSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
